<CFSETTING enablecfoutputonly="Yes">
<!--- 

Project: Maryland ColdFusion User Group

TeraTech, Inc.
100 Park Ave, Ste 360
Rockville, MD  20850
301-424-3903 fax: 301-762-8185
http://www.teratech.com/   info@teratech.com

Copyright TeraTech, Inc 2000.

ELEMENT NAME: mod_display_variables.cfm
	Programmer: Douglas M. Smith
	Created: June 2000
	
Purpose:
	To display/debug various classes of variables: Application, Session, Client, Request, and Cookie
	
Method:
	For stuctures, loop over the structure
	Structure or Arrays inside structures must be handed special
	For non-structured scopes, you must provide a list of variable names

EXAMPLE CALL:
=============

BEST USED IN OnRequestEnd.CFM!

<CF_MOD_DISPLAY_VARIABLES
	Scope_List="APPLICATION,REQUEST,SESSION,CLIENT,FORM,URL,CGI,SERVER..." (REQUIRED)
	Allowed_IP_List="205.193.8.54,205.193.8.55,205.193.8.56" (OPTIONAL)
	Allowed_DOMAIN_List="205.193.8" (OPTIONAL)
	Expand="TRUE/FALSE" (OPTIONAL)
	>

Change History: (CR=Change Request)
--------------
When      Who What
--------- --- -------------------------------------
7/11/2000 dms Turned off display of CF debug text, which was being forced on at the bottom of the page.     
7/12/2000 dms Discovered cookies are a structure in the CF 4.5.1	
3/7/2001  DML default IP list
4/23/2001 Added required attributes, and better user notification of missing attributes.
5/15/2001 Added locking for server, application and session variables
6/12/2001 Added an optional EXPAND attribute to call CF_DUMP to display complex variables.
4/12/2002 Made either the IP list or the Domain list required.

--->

<!--- SETUP SOME LOCAL VARIABLES --->
<CFPARAM Name="DebugAccessAllowed" Default=False>

<!--- ================================================== --->
<!--- MAKE SURE REQUIRED ATTRIBUTES ARE SUBMITTED --->
<!--- ================================================== --->

<CFIF Not IsDefined("Attributes.Allowed_IP_List") OR Not IsDefined("Attributes.Allowed_Domain_List")>
	<CFOUTPUT><font size="5" color="##FF0000"><br clear="all">
	Error using the MOD_DISPLAY_VARIABLES custom tag:<hr noshade>
	You need to supply a parameter called <i>Allowed_IP_List</i> or <i>Allowed_Domain_List</i>. <br>
	The <i>Allowed_IP_List</i> parameter should contain a list of IP addresses that you would like to be allowed to display the debug information.  <br>
	The <i>Allowed_Domain_List</i> parameter should contain a list of domains that you would like to be allowed to display the debug information.
	Domains should be entered/formated as the first 3 tuples of the  IP address.  For example <i>76.123.22</i><br>
	</font></CFOUTPUT>
	<CFEXIT>
</CFIF>

<CFIF Not IsDefined("Attributes.Scope_List")>
	<CFOUTPUT><font size="5" color="##FF0000"><br clear="all">
	Error using the MOD_DISPLAY_VARIABLES custom tag:<hr noshade>
	You need to supply a parameter called <i>SCOPE_LIST</i>.<br>
	This parameter should contain a list of scopes that you want displayed by me.<br>
	For example: SCOPE_LIST="APPLICATION,REQUEST,SESSION,CLIENT,FORM,URL,CGI,SERVER"<br>
	Local variables and structures can be displayed like so:  SCOPE_LIST="caller.variables, caller.attributes, caller.mystruc"<br>
	</font></CFOUTPUT>
	<CFEXIT>
</CFIF>

<CFPARAM name="Attributes.Allowed_IP_List" >
<CFPARAM Name="Attributes.Scope_List" >

<!--- ================================================== --->
<!--- OPTIONAL ATTRIBUTES --->
<!--- ================================================== --->
<CFPARAM Name="Attributes.Allowed_DOMAIN_List" Default="">
<CFPARAM Name="Attributes.Expand" default=FALSE >

<!--- ================================================== --->
<!--- OTHER NON-STRUCTURED SCOPES AND VARIABLES THAT WE WANT TO SEE --->
<!--- WILL USUALLY BE HANDLED WITH A LIST OF VARIABLES --->
<!--- ================================================== --->
<CFSET ServerVarList="Server.ColdFusion.ProductLevel,Server.ColdFusion.ProductName,Server.ColdFusion.ProductVersion,Server.ColdFusion.SerialNumber,Server.ColdFusion.SupportedLocales,Server.OS.AdditionalInformation,Server.OS.BuildNumber,Server.OS.Name,Server.OS.Version">

<!--- ================================================== --->
<!--- USE THIS SECTION TO DECIDE WHAT CONDITIONS DETERMINE --->
<!--- IF THE USER IS ALLOWED TO VIEW THE DEBUG VARIABLES --->
<!--- ================================================== --->

<!--- CURRENT USER IS COMMING FROM AN ALLOWED IP ADDRESS --->
<CFIF ListFindNoCase("#Attributes.Allowed_IP_List#","#CGI.REMOTE_ADDR#")>
		<CFSET DebugAccessAllowed=True>
</cfif>

<CFPARAM Name="CGI.REMOTE_ADDR" Default="">
<!--- CURRENT USER IS COMMING FROM ANYWERE IN A CLASS C DOMAIN  --->
<CFLOOP list="#Attributes.Allowed_DOMAIN_List#" index="Allowed_DOMAIN">
	<CFIF Left(cgi.REMOTE_ADDR,Len(Allowed_DOMAIN)) IS Allowed_DOMAIN>
		<CFSET DebugAccessAllowed=True>
	</cfif>
</cfloop>

<!--- 
<!--- TEST IF A SPECIFIC USER IS LOGGED ON --->
<CFIF ListFindNoCase("#Allowed_UserID_List#","#Client.UserID#")>
		<CFSET DebugAccessAllowed=True>
</cfif>

<!--- TEST IF A USER WITH A SPECIFIC EMAIL ADDRESS IS LOGGED ON --->
<CFIF ListFindNoCase("#Allowed_Email_List#","#Client.Email#")>
		<CFSET DebugAccessAllowed=True>
</cfif>
 --->

<!--- ================================================== --->
<!--- NOW, DISPLAY THE DEBUG VARIABLES IF ALLOWED --->
<!--- ================================================== --->
<CFIF DebugAccessAllowed >
	<cfoutput>
	<hr noshade><font size="5" color="0000FF" face="Arial"><b>MOD_DISPLAY_VARIABLES DEBUG SCREEN</b></font> ----- 
	<b>By <a href="http://www.teratech.com" target="teratech">TeraTech</a> - July 2001</b><br>
	This information is only being displayed for the following IP addresses: #Attributes.Allowed_IP_List#<br>
	This information is only being displayed for the following IP domains: #Attributes.Allowed_Domain_List#<br>
	Expansion of complex variables currently turned <b><CFIF Attributes.Expand>ON<CFELSE>OFF</CFIF></b>
	<HR NOSHADE>

	<!--- LOOP OVER OUR LIST OF SCOPES, AND DETERMINE IF THEY ARE STRUCTURED OR NON-STRUCTURED	--->
	<CFLOOP list="#Attributes.Scope_List#" index="SCOPE">
		<br>
		<!--- <table border="0" cellpadding="0" cellspacing="0" style="font-size: 12;font-family: arial" width="100%"> --->

		<!--- NON STRUCTURED SCOPES MUST BE HANDLED DIFFERENTLY --->
		<CFIF SCOPE IS "Client" >
	
			<table width="100%" border="1" cellspacing="0" cellpadding="3" style="font-size: 12; font-family: arial">
			<!--- CLIENT VARS ARE NOT STORED IN A STRUCTURE, SO THEY CAN'T BE LOOPED THROUGH --->
			<!--- However, we can use the new function available in CF 4.5: GetClientVariablesList() --->
			<tr bgcolor="eeeeee"><td colspan=2><b>CLIENT VARIABLES</b></td></tr>
			<CFTRY>
			<CFLOOP list="#ListSort(GetClientVariablesList(),"text")#" index="CurKey">
				<TR><TD valign="top" width="5">#CurKey#</td><td><b><CFIF IsDefined("Client.#CurKey#")>#Evaluate("client.#CurKey#")#<cfelse>[NOT DEFINED]</cfif></b></td></tr>
			</cfloop>
			<!--- OTHER CLIENT VARIABLES THAT FOR SOME REASON ARE NOT INCLUDED IN GETCLIENTVARIABLESLIST --->
			<TR><TD width="5">HitCount</td><td><b><CFIF IsDefined("Client.HitCount")>#Client.HitCount#<cfelse>[NOT DEFINED]</cfif></b></td></tr>
			<TR><TD width="5">LastVisit</td><td><b><CFIF IsDefined("Client.LastVisit")>#Client.LastVisit#<cfelse>[NOT DEFINED]</cfif></b></td></tr>
			<CFCATCH type="Any">
				<TR><TD width="5"></TD><TD><b><font color="FF0000">CLIENT VARS ARE CURRENTLY NOT ENABLED IN CFAPPLICATION TAG</font></b></TD></TR>
			</CFCATCH>
			</CFTRY>
			</table>
			
		<!--- NON STRUCTURED SCOPES MUST BE HANDLED DIFFERENTLY --->
		<CFELSEIF SCOPE IS "Server">

			<table width="100%" border="1" cellspacing="0" cellpadding="3" style="font-size: 12; font-family: arial">
			<!--- SERVER VARIABLES --->
			<tr bgcolor="eeeeee"><td colspan=2><b>SERVER VARIABLES</b></td></tr>
			<CFLOCK scope="SERVER" type="READONLY" timeout="5">
			<CFLOOP list="#ServerVarList#" index="CurKey">
				<TR><TD valign="top" width="5">#CurKey#</td><td valign="top"><b><CFIF IsDefined("#CurKey#")>#Evaluate(CurKey)#<cfelse>[NOT DEFINED]</cfif></b></td></tr>
			</cfloop>
			</cflock>
			</table>
					
		<!--- WE ARE GOOD TO GO WITH ANY REMAINING STRUCTURED SCOPES--->
		<CFELSEIF IsDefined(SCOPE) AND IsStruct(Evaluate(SCOPE))>
	
<!--- 			<!--- APPLICATION AND SESSION SCOPES MUST BE LOCKED --->
			<CFIF SCOPE IS "Application" OR SCOPE IS "Session">
				<cflock timeout="5" throwontimeout="No" type="READONLY" scope="APPLICATION">
			</cfif>
 --->			
 			
			<CFIF Attributes.Expand>
				<CF_DUMP variable="#scope#">
			<CFELSE>
				<table width="100%" border="1" cellspacing="0" cellpadding="3" style="font-size: 12; font-family: arial">
				<tr bgcolor="eeeeee"><td colspan=2><b>#SCOPE# VARIABLES</b></td></tr>
				<tr>
				<cfloop collection="#evaluate(scope)#" item="VarName" >
					<CFSET MyVar=Evaluate("#scope#.#VarName#")>
					<tr><td valign="top" width="5">#VarName#</td>
					<cfif IsQuery(MyVar)>
					<td><b>Complex Variable: Query</b></td>
					<cfelseif IsStruct(MyVar)>
					<td><b>Complex Variable: Structure</b></td>
					<cfelse>
					<td><b>#HTMLEditFormat(Evaluate("#scope#.#VarName#"))#</b>&nbsp;</td>
					</cfif>
				</cfloop>
				</TR>
				</table>
			</CFIF> <!--- END UseCF_DUMP --->

			<!--- CLOSE LOCK --->
<!--- 			<CFIF SCOPE IS "Application" OR SCOPE IS "Session">
				</cflock>
			</cfif>
 --->
		<cfelse>
			<CFABORT showerror="Error in MOD_DISPLAY_VARIABLES: #scope# is not a valid structure or is not a handled scope in this tag.  You will need to remove this scope from the Scope_List.">
		</cfif>
		</table>
	</cfloop>
	</cfoutput>
</cfif>

<CFSETTING enablecfoutputonly="NO">
